#include "exif.h"


struct exif_ifd_field exif_ifd_fields[]=
{
	{	EXIF_IFD_IMAGE_WIDTH,						ULONG,		  1,	"image width"	},
	{	EXIF_IFD_IMAGE_HEIGHT,						ULONG,		  1,	"image height"	},
	{	EXIF_IFD_BITS_PER_SAMPLE,					USHORT,		  3,	"bits per sample"	},
	{	EXIF_IFD_COMPRESSION,						USHORT,		  1,	"compression"	},
	{	EXIF_IFD_PHOTOMETRIC_INTERPRETATION,		USHORT,		  1,	"photometric interpretation"	},
	{	EXIF_IFD_IMAGE_DESCR,						STRING,		 20,	"image description" },
	{	EXIF_IFD_MAKE,								STRING,		  6,	"make" },
	{	EXIF_IFD_MODEL,								STRING,		 20,	"model" },
	{	EXIF_IFD_STRIP_OFFSETS,						ULONG,		  1,	"strip offsets" },
	{	EXIF_IFD_ORIENTATION,						USHORT,		  1,	"orientation" },
	{	EXIF_IFD_SAMPLES_PER_PIXEL,					USHORT,		  1,	"samples per pixel" },
	{	EXIF_IFD_ROWS_PER_STRIP,					ULONG,		  1,	"rows per strip" },
	{	EXIF_IFD_STRIP_BYTE_COUNT,					ULONG,		  1,	"strip byte count" },
	{	EXIF_IFD_XRES,								URATIONAL,	  1,	"x resolution" },
	{	EXIF_IFD_YRES,								URATIONAL,	  1,	"y resolution" },
	{	EXIF_IFD_RES_UNIT,							USHORT,		  1,	"resolution unit" },
	{	EXIF_IFD_SOFTWARE,							STRING,		 23,	"software" },
	{	EXIF_IFD_DATE_TIME,							STRING,		 20,	"date/time" },

	{	EXIF_IFD_JPEG_IF_OFFSET,					ULONG,		  1,	"JPEG IF offset" },
	{	EXIF_IFD_JPEG_IF_BYTE_COUNT,				ULONG,		  1,	"JPEG IF byte count" },
	{	EXIF_IFD_YCBCR_POS,							USHORT,		  1,	"YCbCr positioning" },

	{	EXIF_IFD_EXPOSURE_TIME,						URATIONAL,	  1,	"exposure time" },
	{	EXIF_IFD_F_NUMBER,							URATIONAL,	  1,	"F number" },
	{	EXIF_IFD_OFFSET,							ULONG,		  1,	"EXIF offset" },
	{	EXIF_IFD_LOCATION_OFFSET,					URATIONAL,	000,	"location offset" },
	{	EXIF_IFD_EXPOSURE_PROGRAM,					USHORT,		  1,	"exposure program" },
	{	EXIF_IFD_ISO_SPEED_RATINGS,					USHORT,		  1,	"ISO speed ratings" },

	{	EXIF_IFD_EXIF_VERSION,						UNDEFINED,	  4,	"EXIF version" },
	{	EXIF_IFD_ORIG_DATE_TIME,					STRING,		 20,	"original date/time" },
	{	EXIF_IFD_DIGIT_DATE_TIME,					STRING,		 20,	"digitized date/time" },
	{	EXIF_IFD_COMPONENT_CONFIG,					UNDEFINED,	  4,	"component configuration" },
	{	EXIF_IFD_COMPRESSION_RATE,					URATIONAL,	  1,	"compression bits/pixel" },
	{	EXIF_IFD_SHUTTER_SPEED,						SRATIONAL,	  1,	"shutter speed" },
	{	EXIF_IFD_APERTURE,							URATIONAL,	  1,	"aperture" },
	{	EXIF_IFD_BRIGHTNESS,						SRATIONAL,	  1,	"brightness" },
	{	EXIF_IFD_EXPOSURE_BIAS,						SRATIONAL,	  1,	"exposure bias" },
	{	EXIF_IFD_MAX_APERTURE,						URATIONAL,	  1,	"max aperture" },
	{	EXIF_IFD_SUBJECT_DISTANCE,					URATIONAL,	  1,	"subject distance" },
	{	EXIF_IFD_METERING_MODE,						USHORT,		  1,	"metering mode" },
	{	EXIF_IFD_LIGHT_SOURCE,						USHORT,		  1,	"light source" },
	{	EXIF_IFD_FLASH,								USHORT,		  1,	"flash" },
	{	EXIF_IFD_FOCAL_LENGTH,						URATIONAL,	  1,	"focal length" },
	{	EXIF_IFD_MAKER_NOTE,						UNDEFINED,	 -1,	"maker note" },
	{	EXIF_IFD_USER_COMMENT,						UNDEFINED,	 -1,	"user comment" },

	{	EXIF_IFD_FLASH_PIX_VERSION,					UNDEFINED,	  4,	"flash pix version" },
	{	EXIF_IFD_COLOR_SPACE,						USHORT,		  1,	"color space" },
	{	EXIF_IFD_IMAGE_WIDTH,						ULONG,		  1,	"EXIF image width" },
	{	EXIF_IFD_IMAGE_HEIGHT,						ULONG,		  1,	"EXIF image height" },
	{	EXIF_IFD_SOUND_FILE,						URATIONAL,	000,	"sound file" },
	{	EXIF_IFD_INTEROPE_OFFSET,					ULONG,		  1,	"EXIF interoperability offset" },
	{	EXIF_IFD_FOCAL_PLANE_XRES,					URATIONAL,	  1,	"focal plane x resolution" },
	{	EXIF_IFD_FOCAL_PLANE_YRES,					URATIONAL,	  1,	"focal plane y resolution" },
	{	EXIF_IFD_FOCAL_PLANE_RES_UNIT,				USHORT,		  1,	"focal plane res unit" },
	{	EXIF_IFD_SENSING_METHOD,					USHORT,		  2,	"sensing method" },
	{	EXIF_IFD_FILE_SOURCE,						UNDEFINED,	  1,	"file source" },
	{	EXIF_IFD_SCENE_TYPE,						UNDEFINED,	  1,	"scene type" },
	/* reserved */
	{	EXIF_IFD_EOT, UNDEFINED, 0, NULL }
};

struct exif_interope_field exif_interope_fields[]=
{
	{	EXIF_INTEROPE_INDEX,						STRING,		  4,	"index" },
	{	EXIF_INTEROPE_VERSION,						UNDEFINED,	  4,	"version" },
	{	EXIF_INTEROPE_IMAGE_WIDTH,					USHORT,		  1,	"image width" },
	{	EXIF_INTEROPE_IMAGE_HEIGHT,					USHORT,		  1,	"image height" },
	/* reserved */
	{	EXIF_INTEROPE_EOT, UNDEFINED, 0, NULL }
};

struct exif_location_field exif_location_fields[]=
{
	{	EXIF_LOCATION_CONTINENT,					STRING,		 -1,	"continent" },
	{	EXIF_LOCATION_COUNTRY,						STRING,		  2,	"country (ISO 3166)" },
	{	EXIF_LOCATION_COUNTRY_OTHER,				STRING,		 -1,	"country/other" },
	{	EXIF_LOCATION_REGION,						STRING,		 -1,	"region" },
	{	EXIF_LOCATION_AREA,							STRING,		 -1,	"area" },
	{	EXIF_LOCATION_SUB_AREA,						STRING,		 -1,	"sub-area" },
	{	EXIF_LOCATION_PLACE,						STRING,		 -1,	"place" },
	{	EXIF_LOCATION_PLACE_AREA,					STRING,		 -1,	"place area" },
	{	EXIF_LOCATION_LOCATION,						STRING,		 -1,	"location" },
	{	EXIF_LOCATION_ADDRESS,						STRING,		 -1,	"address" },
	{	EXIF_LOCATION_POSTAL_CODE,					STRING,		 -1,	"postal code" },
	{	EXIF_LOCATION_DESCRIPTION,					STRING,		 -1,	"description" },
	/* reserved */
	{	EXIF_LOCATION_EOT, UNDEFINED, 0, NULL }
};

struct exif_canon_field exif_canon_fields[]=
{
	{	EXIF_CANON_MAKER_NOTE_UNKNOWN1,				USHORT,		  6,	"unknown1" },
	{	EXIF_CANON_MAKER_NOTE_UNKNOWN2,				USHORT,		 19,	"unknown2" },
	{	EXIF_CANON_MAKER_NOTE_UNKNOWN3,				USHORT,		  4,	"unknown3" },
	{	EXIF_CANON_MAKER_NOTE_UNKNOWN4,				USHORT,		  4,	"unknown4" },
	{	EXIF_CANON_MAKER_NOTE_UNKNOWN5,				USHORT,		 15,	"unknown5" },
	{	EXIF_CANON_MAKER_NOTE_IMAGE_TYPE,			STRING,		 32,	"image type" },
	{	EXIF_CANON_MAKER_NOTE_FIRMWARE_VERSION,		STRING,		 24,	"firmware version" },
	{	EXIF_CANON_MAKER_NOTE_IMAGE_NUMBER,			ULONG,		  1,	"image number" },
	{	EXIF_CANON_MAKER_NOTE_OWNER_NAME,			STRING,		 32,	"owner name" },
	{	EXIF_CANON_MAKER_NOTE_UNKNOWN6,				ULONG,		  1,	"unknown6" },
	/* reserved */
	{	EXIF_CANON_EOT, UNDEFINED, 0, NULL }
};

struct exif_fuji_field exif_fuji_fields[]=
{
	{	EXIF_FUJI_MAKER_NOTE_VERSION,				UNDEFINED,	  4,	"version" },
	{	EXIF_FUJI_MAKER_NOTE_QUALITY,				STRING,		  8,	"quality" },
	{	EXIF_FUJI_MAKER_NOTE_SHARPNESS,				USHORT,		  1,	"sharpness" },
	{	EXIF_FUJI_MAKER_NOTE_WHITE_BALANCE,			USHORT,		  1,	"white balance" },
	{	EXIF_FUJI_MAKER_NOTE_FLASH_MODE,			USHORT,		  1,	"flash mode" },
	{	EXIF_FUJI_MAKER_NOTE_FLASH_STRENGTH,		SRATIONAL,	  1,	"flash strength" },
	{	EXIF_FUJI_MAKER_NOTE_MACRO,					USHORT,		  1,	"macro" },
	{	EXIF_FUJI_MAKER_NOTE_FOCUS_MODE,			USHORT,		  1,	"focus mode" },
	{	EXIF_FUJI_MAKER_NOTE_SLOW_SYNC,				USHORT,		  1,	"slow sync" },
	{	EXIF_FUJI_MAKER_NOTE_PICTURE_MODE,			USHORT,		  1,	"picture mode" },
	{	EXIF_FUJI_MAKER_NOTE_CONT_TAKE_BRACKET,		USHORT,		  1,	"contTake/bracket" },
	{	EXIF_FUJI_MAKER_NOTE_UNKNOWN,				USHORT,		  1,	"unknown" },
	{	EXIF_FUJI_MAKER_NOTE_BLUR_WARNING,			USHORT,		  1,	"blur warning" },
	{	EXIF_FUJI_MAKER_NOTE_FOCUS_WARNING,			USHORT,		  1,	"focus warning" },
	{	EXIF_FUJI_MAKER_NOTE_AE_WARNING,			USHORT,		  1,	"ae warning" },
	/* reserved */
	{	EXIF_FUJI_EOT, UNDEFINED, 0, NULL }
};

struct exif_nikon_field exif_nikon_fields[]=
{
	{	EXIF_NIKON_MAKER_NOTE_UNKNOWN1,				STRING,		  6,	"unknown1" },
	{	EXIF_NIKON_MAKER_NOTE_UNKNOWN2,				USHORT,		  1,	"unknown2" },
	{	EXIF_NIKON_MAKER_NOTE_UNKNOWN3,				USHORT,		  1,	"unknown3" },
	{	EXIF_NIKON_MAKER_NOTE_UNKNOWN4,				USHORT,		  1,	"unknown4" },
	{	EXIF_NIKON_MAKER_NOTE_UNKNOWN5,				USHORT,		  1,	"unknown5" },
	{	EXIF_NIKON_MAKER_NOTE_UNKNOWN6,				USHORT,		  1,	"unknown6" },
	{	EXIF_NIKON_MAKER_NOTE_UNKNOWN7,				URATIONAL,	  1,	"unknown7" },
	{	EXIF_NIKON_MAKER_NOTE_UNKNOWN8,				STRING,		 20,	"unknown8" },
	{	EXIF_NIKON_MAKER_NOTE_UNKNOWN9,				URATIONAL,	  1,	"unknown9" },
	{	EXIF_NIKON_MAKER_NOTE_UNKNOWN10,			USHORT,		  1,	"unknown10" },
	{	EXIF_NIKON_MAKER_NOTE_DATA_DUMP,			ULONG,		 30,	"data dump" },
	/* reserved */
	{	EXIF_NIKON_EOT, UNDEFINED, 0, NULL }
};

struct exif_sanyo_field exif_sanyo_fields[]=
{
	{	EXIF_SANYO_MAKER_NOTE_START_OFFSET,				USHORT,		1,	"makernote start offset" },
	{	EXIF_SANYO_MAKER_NOTE_JPEG_THUMBNAIL,			UNDEFINED,	-1,	"JPEG thumbnail data" },
	{	EXIF_SANYO_MAKER_NOTE_SPECIAL_MODE,				ULONG,		3,	"special mode" },
	{	EXIF_SANYO_MAKER_NOTE_JPEQ_QUALITY,				USHORT,		1,	"JPEG quality" },
	{	EXIF_SANYO_MAKER_NOTE_MACRO,					USHORT,		1,	"macro" },
	{	EXIF_SANYO_MAKER_NOTE_UNKNOWN1,					USHORT,		1,	"unknown1" },
	{	EXIF_SANYO_MAKER_NOTE_DIGITAL_ZOOM1,			URATIONAL,	1,	"digital zoom (1)" },
	{	EXIF_SANYO_MAKER_NOTE_UNKNOWN2,					URATIONAL,	1,	"unknown2" },
	{	EXIF_SANYO_MAKER_NOTE_UNKNOWN3,					USHORT,		6,	"unknown3" },
	{	EXIF_SANYO_MAKER_NOTE_SOFTWARE_RELEASE,			STRING,		-1,	"software release" },
	{	EXIF_SANYO_MAKER_NOTE_PICT_INFO,				STRING,		-1,	"pict info" },
	{	EXIF_SANYO_MAKER_NOTE_CAMERA_ID,				UNDEFINED,	32,	"camera ID" },
	{	EXIF_SANYO_MAKER_NOTE_SEQUENTIAL_SHOT_METHOD,	USHORT,  	1,	"sequential shot method" },
	{	EXIF_SANYO_MAKER_NOTE_WIDE_RANGE,				USHORT,  	1,	"wide range" },
	{	EXIF_SANYO_MAKER_NOTE_COLOUR_ADJUSTMENT_MODE,	USHORT,  	1,	"colour adjustment mode" },
	{	EXIF_SANYO_MAKER_NOTE_QUICK_SHOT,				USHORT,  	1,	"quick shot" },
	{	EXIF_SANYO_MAKER_NOTE_SELF_TIMER,				USHORT,  	1,	"self timer" },
	{	EXIF_SANYO_MAKER_NOTE_VOICE_MEMO,				USHORT,  	1,	"voice memo" },
	{	EXIF_SANYO_MAKER_NOTE_RECORD_SHUTTER_RELEASE,	USHORT,  	1,	"record shutter release" },
	{	EXIF_SANYO_MAKER_NOTE_FLICKER_REDUCE,			USHORT,  	1,	"flicker reduce" },
	{	EXIF_SANYO_MAKER_NOTE_OPTICAL_ZOOM,				USHORT,  	1,	"optical zoom" },
	{	EXIF_SANYO_MAKER_NOTE_DIGITAL_ZOOM2,			USHORT,  	1,	"digital zoom (2)" },
	{	EXIF_SANYO_MAKER_NOTE_LIGHT_SOURCE_SPECIAL,		USHORT,  	1,	"light source special" },
	{	EXIF_SANYO_MAKER_NOTE_RESAVED,					USHORT,  	1,	"resaved" },
	{	EXIF_SANYO_MAKER_NOTE_SCENE_SELECT,				USHORT,  	1,	"scene select" },
	{	EXIF_SANYO_MAKER_NOTE_MANUAL_FOCAL_DISTANCE,	URATIONAL,  1,	"manual focal distance" },
	{	EXIF_SANYO_MAKER_NOTE_SEQUENTIAL_SHOT_INTERVAL,	USHORT,  	1,	"sequential shot interval" },
	{	EXIF_SANYO_MAKER_NOTE_FLASH_MODE,				USHORT,  	1,	"flash mode" },
	{	EXIF_SANYO_MAKER_NOTE_PRINTIM_FLAGS,			UNDEFINED,	-1,	"printIM flags" },
	{	EXIF_SANYO_MAKER_NOTE_DATA_DUMP,				ULONG,		-1,	"data dump" },
	/* reserved */
	{	EXIF_SANYO_EOT, UNDEFINED, 0, NULL }
};


void exif_parse(unsigned char* buffer, const unsigned int bytes_left, struct parser_result* result)
{
	error("Exif parsing is not implemented");
	result->parsed_bytes=0;
	result->ret=false;
}

void exif_match_type(const enum EXIF_TYPE type)
{
}

void exif_dump_list(void)
{
}
